(format t "~%~%This is the Sierra 2 system -- loaded sierra.lisp")
(format t "~%~%(setseed <n>) to change the random seed.")
(format t "~%(setparams <copyerror> <cosmicerror>) to set parameters.")
(format t "~%(setseed <seed>) to set the random number seed.")
(format t "~%(status) to get the current status of the run.")
(format t "~%(run) to run for 100,000,000 more instructions.")
(format t "~%(run <n>) to run for <n> more instructions.")
(format t "~%(stop) to stop it running immediately.")
(format t "~%~%(rep) to report on the current status of the population.")
(format t "~%(best) to print the ids of the best genomes so far.")
(format t "~%(genomes <size>) to list good genomes of that size.")
(format t "~%(print-genome <id>) tells about that genome's success.")
(format t "~%(print-code <id>) lists its code.")
(format t "~%(populations) tells about the best current genomes of each size.")
(format t "~%")

(defparameter *ancestor* (get-ancestor))

(defun print-genome (thing)
  (if (fixnump thing)
      (print-gen (get-genome thing))
    (print-gen thing)))

(defun print-code (thing)
  (if (fixnump thing)
      (print-cod (get-genome thing))
    (print-cod thing)))

(defun setparams (copy cosmic)
  (setparamsint copy cosmic)
  (format t "~%Copy errors 1 every ~d, cosmic rays 1 every ~d instructions."
	  copy
	  cosmic)
  't)

(defun setseed (n)
  (setseedint n)
  (format t "~%Random seed is ~d." n)
  't)

(format t "~%Current settings:")

(setparams 10000 1000)

(setseed 37)

(defun run (&optional (more 100000000)) (runsierra more))

(defun status ()
  (let ((result (repstatus)))
    (if (= result 0)
	(format t "~&Not started")
      (if (> result 0)
	  (format t "~&Running at ~S" result)
	(format t "~&Idle at ~S" (- result)))))
  '())

(format t "~%~%")
