;;; this is the startup file for FELL.

;;; it defines a number of parts of the language in a smaller subset of it

(defmacro cond (&rest forms)
  (if (null forms)
      '()
    `(if ,(first (first forms)) (progn ,@(rest (first forms))) (cond ,@(rest forms)))))


(defmacro do (argforms endtest &rest forms)
  (let ((argnames (mapcar #'first argforms))
		(inits (mapcar #'second argforms))
		(steps (mapcar #'third argforms))
		(varname (gensym)))
	`(block ()
	   (let ,(mapcar #'list argnames inits)
	     (tagbody
	        ,varname
	        (if ,(first endtest) (return (progn ,@(rest endtest))))
	        ,@forms
	        (let ((,varname (list ,@steps)))
	          ,@(mapcar #'(lambda (argname) `(progn (setq ,argname (first ,varname))
	          										(setq ,varname (rest ,varname))))
	          			argnames))
	        (go ,varname))))))

(format t "  ... loaded startup.lisp")


